package kr.co.vividnext.sodalive.content.comment

import kr.co.vividnext.sodalive.common.BaseEntity
import kr.co.vividnext.sodalive.content.AudioContent
import kr.co.vividnext.sodalive.member.Member
import javax.persistence.Column
import javax.persistence.Entity
import javax.persistence.FetchType
import javax.persistence.JoinColumn
import javax.persistence.ManyToOne
import javax.persistence.OneToMany
import javax.persistence.Table

@Entity
@Table(name = "content_comment")
data class AudioContentComment(
    @Column(columnDefinition = "TEXT", nullable = false)
    var comment: String,
    @Column(nullable = true)
    var donationCan: Int? = null,
    var isActive: Boolean = true
) : BaseEntity() {
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "parent_id", nullable = true)
    var parent: AudioContentComment? = null
        set(value) {
            value?.children?.add(this)
            field = value
        }

    @OneToMany(mappedBy = "parent")
    var children: MutableList<AudioContentComment> = mutableListOf()

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "member_id", nullable = false)
    var member: Member? = null

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "content_id", nullable = false)
    var audioContent: AudioContent? = null
}
