package kr.co.vividnext.sodalive.member.notification

import kr.co.vividnext.sodalive.member.Member
import org.springframework.stereotype.Service
import org.springframework.transaction.annotation.Transactional

@Service
@Transactional(readOnly = true)
class MemberNotificationService(private val repository: MemberNotificationRepository) {
    fun updateNotification(
        live: Boolean? = null,
        uploadContent: Boolean? = null,
        message: Boolean? = null,
        member: Member
    ) {
        var notification = repository.getMemberNotification(memberId = member.id!!)
        if (notification == null) {
            notification = MemberNotification(uploadContent, live, message)
            notification.member = member
            repository.save(notification)
        } else {
            if (live != null) notification.live = live
            if (message != null) notification.message = message
            if (uploadContent != null) notification.uploadContent = uploadContent
        }
    }
}
