package kr.co.vividnext.sodalive.menu

import kr.co.vividnext.sodalive.common.ApiResponse
import org.springframework.security.access.prepost.PreAuthorize
import org.springframework.security.core.annotation.AuthenticationPrincipal
import org.springframework.security.core.userdetails.User
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@RequestMapping("/menu")
class MenuController(private val service: MenuService) {
    @GetMapping
    @PreAuthorize("hasAnyRole('AGENT', 'ADMIN', 'CREATOR')")
    fun getMenus(@AuthenticationPrincipal user: User) = ApiResponse.ok(service.getMenus(user))
}
